'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/** Component for displaying flash and error messages */

var Badge = function Badge(_ref, _ref2) {
  var type = _ref.type;
  var pill = _ref.pill;
  var circle = _ref.circle;
  var style = _ref.style;

  var props = _objectWithoutProperties(_ref, ['type', 'pill', 'circle', 'style']);

  var rebass = _ref2.rebass;

  var config = _extends({}, _theme2.default, rebass);
  var customStyle = rebass ? rebass.Badge : {};
  var fontSizes = config.fontSizes;
  var bold = config.bold;
  var scale = config.scale;
  var colors = config.colors;
  var borderRadius = config.borderRadius;

  var backgroundColor = colors[type];

  return _react2.default.createElement('div', _extends({}, props, {
    className: 'Badge',
    style: _extends({
      fontSize: fontSizes[6],
      fontWeight: bold,
      boxSizing: 'border-box',
      display: 'inline-flex',
      alignItems: 'center',
      justifyContent: 'center',
      width: circle ? scale[2] : null,
      height: scale[2],
      paddingTop: 0,
      paddingBottom: 0,
      paddingLeft: circle ? 0 : scale[1],
      paddingRight: circle ? 0 : scale[1],
      overflow: 'hidden',
      color: colors.white,
      borderRadius: circle || pill ? 99999 : borderRadius,
      backgroundColor: backgroundColor
    }, customStyle, style) }));
};

Badge.propTypes = {
  /** Sets color based on type of badge */
  type: _react2.default.PropTypes.oneOf(['default', 'info', 'success', 'warning', 'error']),
  /** Sets pill style border radii */
  pill: _react2.default.PropTypes.bool,
  /** Sets width and border radius for circular badges */
  circle: _react2.default.PropTypes.bool
};

Badge.defaultProps = {
  type: 'default'
};

Badge.contextTypes = {
  rebass: _react2.default.PropTypes.object
};

exports.default = Badge;