'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * A circular button suited for use with icons
 */

var ButtonCircle = function ButtonCircle(_ref, _ref2) {
  var href = _ref.href;
  var size = _ref.size;
  var color = _ref.color;
  var backgroundColor = _ref.backgroundColor;
  var children = _ref.children;
  var style = _ref.style;

  var props = _objectWithoutProperties(_ref, ['href', 'size', 'color', 'backgroundColor', 'children', 'style']);

  var rebass = _ref2.rebass;

  var config = _extends({}, _theme2.default, rebass);
  var customStyle = rebass ? rebass.ButtonCircle : {};
  var scale = config.scale;
  var colors = config.colors;

  var Component = href ? 'a' : 'button';

  color = colors[color] || color || colors.white;
  backgroundColor = colors[backgroundColor] || backgroundColor || colors.primary;

  var sx = {
    root: _extends({
      fontFamily: 'inherit',
      fontSize: 'inherit',
      lineHeight: scale[2] + 'px',
      textDecoration: 'none',
      boxSizing: 'border-box',
      display: 'inline-block',
      width: size || scale[3],
      height: size || scale[3],
      margin: 0,
      padding: 0,
      cursor: 'pointer',
      color: color,
      backgroundColor: backgroundColor,
      border: 0,
      borderRadius: 99999
    }, customStyle, style),
    inner: {
      display: 'flex',
      width: size || scale[3],
      height: size || scale[3],
      alignItems: 'center',
      justifyContent: 'center'
    }
  };

  return _react2.default.createElement(
    Component,
    _extends({}, props, {
      className: 'ButtonCircle',
      style: sx.root }),
    _react2.default.createElement(
      'div',
      { style: sx.inner },
      children
    )
  );
};

ButtonCircle.propTypes = {
  /** Pass an href prop to make the ButtonCircle an <a> tag instead of a <button> */
  href: _react2.default.PropTypes.string,
  /** Text color - can either be a key from the theme colors object or any color value */
  color: _react2.default.PropTypes.string,
  /** Background color - can either be a key from the theme colors object or any color value */
  backgroundColor: _react2.default.PropTypes.string,
  /** Sets width and height of button */
  size: _react2.default.PropTypes.number
};

ButtonCircle.contextTypes = {
  rebass: _react2.default.PropTypes.object
};

exports.default = ButtonCircle;