'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * Unstyled display block link
 */

var LinkBlock = function LinkBlock(_ref, _ref2) {
  var Component = _ref.Component;
  var style = _ref.style;

  var props = _objectWithoutProperties(_ref, ['Component', 'style']);

  var rebass = _ref2.rebass;

  var customStyle = rebass ? rebass.LinkBlock : {};

  var sx = _extends({
    display: 'block',
    textDecoration: 'none',
    color: 'inherit'
  }, customStyle, style);

  return _react2.default.createElement(Component, _extends({}, props, {
    className: 'LinkBlock',
    style: sx }));
};

LinkBlock.propTypes = {
  /** Root component - useful for use with react-router's Link component */
  Component: _react2.default.PropTypes.node
};

LinkBlock.defaultProps = {
  Component: 'a'
};

LinkBlock.contextTypes = {
  rebass: _react2.default.PropTypes.object
};

exports.default = LinkBlock;