'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

/**
 * Utility for extracting padding props from components
 */

var n = function n(x) {
  return typeof x === 'number';
};

function padding(props, scale) {
  var s = scale || [];

  var _ref = props || {};

  var p = _ref.p;
  var px = _ref.px;
  var py = _ref.py;
  var pt = _ref.pt;
  var pr = _ref.pr;
  var pb = _ref.pb;
  var pl = _ref.pl;

  var result = {};

  if (n(p)) {
    result.padding = s[p];
  }

  if (n(py)) {
    result.paddingTop = s[py];
    result.paddingBottom = s[py];
  } else {
    if (n(pt)) {
      result.paddingTop = s[pt];
    }
    if (n(pb)) {
      result.paddingBottom = s[pb];
    }
  }

  if (n(px)) {
    result.paddingLeft = s[px];
    result.paddingRight = s[px];
  } else {
    if (n(pl)) {
      result.paddingLeft = s[pl];
    }
    if (n(pr)) {
      result.paddingRight = s[pr];
    }
  }

  return result;
}

exports.default = padding;